package jdk.internal.org.objectweb.asm.tree.analysis;

import java.util.List;
import jdk.internal.org.objectweb.asm.tree.AbstractInsnNode;
import jdk.internal.org.objectweb.asm.Type;

public abstract class Interpreter<V extends Value>
{
    protected final int api;
    
    protected Interpreter(int api) {
        this.api = api;
    }
    
    public abstract V newValue(Type p0);
    
    public abstract V newOperation(AbstractInsnNode p0) throws AnalyzerException;
    
    public abstract V copyOperation(AbstractInsnNode p0, V p1) throws AnalyzerException;
    
    public abstract V unaryOperation(AbstractInsnNode p0, V p1) throws AnalyzerException;
    
    public abstract V binaryOperation(AbstractInsnNode p0, V p1, V p2) throws AnalyzerException;
    
    public abstract V ternaryOperation(AbstractInsnNode p0, V p1, V p2, V p3) throws AnalyzerException;
    
    public abstract V naryOperation(AbstractInsnNode p0, List<? extends V> p1) throws AnalyzerException;
    
    public abstract void returnOperation(AbstractInsnNode p0, V p1, V p2) throws AnalyzerException;
    
    public abstract V merge(V p0, V p1);
}
